"use strict";
// *** WARNING: this file was generated by Pulumi SDK Generator. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertManager = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Automates the management and issuance of TLS certificates from various issuing sources within Kubernetes
 */
class CertManager extends pulumi.ComponentResource {
    /**
     * Create a CertManager resource with the given unique name, arguments, and options.
     *
     * @param name The _unique_ name of the resource.
     * @param args The arguments to use to populate this resource's properties.
     * @param opts A bag of options that control this resource's behavior.
     */
    constructor(name, args, opts) {
        let inputs = {};
        opts = opts || {};
        if (!opts.id) {
            inputs["affinity"] = args ? args.affinity : undefined;
            inputs["cainjector"] = args ? args.cainjector : undefined;
            inputs["clusterResourceNamespace"] = args ? args.clusterResourceNamespace : undefined;
            inputs["containerSecurityContext"] = args ? args.containerSecurityContext : undefined;
            inputs["deploymentAnnotations"] = args ? args.deploymentAnnotations : undefined;
            inputs["extraArgs"] = args ? args.extraArgs : undefined;
            inputs["extraEnv"] = args ? args.extraEnv : undefined;
            inputs["extraVolumeMounts"] = args ? args.extraVolumeMounts : undefined;
            inputs["extraVolumes"] = args ? args.extraVolumes : undefined;
            inputs["featureGates"] = args ? args.featureGates : undefined;
            inputs["global"] = args ? args.global : undefined;
            inputs["helmOptions"] = args ? args.helmOptions : undefined;
            inputs["http_proxy"] = args ? args.http_proxy : undefined;
            inputs["https_proxy"] = args ? args.https_proxy : undefined;
            inputs["image"] = args ? args.image : undefined;
            inputs["ingressShim"] = args ? args.ingressShim : undefined;
            inputs["installCRDs"] = args ? args.installCRDs : undefined;
            inputs["no_proxy"] = args ? args.no_proxy : undefined;
            inputs["nodeSelector"] = args ? args.nodeSelector : undefined;
            inputs["podAnnotations"] = args ? args.podAnnotations : undefined;
            inputs["podDnsConfig"] = args ? args.podDnsConfig : undefined;
            inputs["podDnsPolicy"] = args ? args.podDnsPolicy : undefined;
            inputs["podLabels"] = args ? args.podLabels : undefined;
            inputs["prometheus"] = args ? args.prometheus : undefined;
            inputs["replicaCount"] = args ? args.replicaCount : undefined;
            inputs["resources"] = args ? args.resources : undefined;
            inputs["securityContext"] = args ? args.securityContext : undefined;
            inputs["serviceAccount"] = args ? args.serviceAccount : undefined;
            inputs["serviceAnnotations"] = args ? args.serviceAnnotations : undefined;
            inputs["serviceLabels"] = args ? args.serviceLabels : undefined;
            inputs["startupapicheck"] = args ? args.startupapicheck : undefined;
            inputs["strategy"] = args ? args.strategy : undefined;
            inputs["tolerations"] = args ? args.tolerations : undefined;
            inputs["webhook"] = args ? args.webhook : undefined;
            inputs["status"] = undefined /*out*/;
        }
        else {
            inputs["status"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(CertManager.__pulumiType, name, inputs, opts, true /*remote*/);
    }
    /**
     * Returns true if the given object is an instance of CertManager.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === CertManager.__pulumiType;
    }
}
exports.CertManager = CertManager;
/** @internal */
CertManager.__pulumiType = 'kubernetes-cert-manager:index:CertManager';
//# sourceMappingURL=certManager.js.map